/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of DIVA base library.
 *
 * Author(s): Jarmo Hiipakka and Tommi Ilmonen, 2000-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * DIVA - Digital Interactive Virtual Acoustics group 
 * Telecommunications Software and Multimedia Laboratory
 * Helsinki University of Technology
 * Finland
 *
 * http://www.tml.hut.fi/Research/DIVA/
 *
 * DIVA base library is licensed under GNU Lesser General Public
 * License (LGPL). The LGPL conditions can be found in file "LGPL"
 * that is distributed with this source package or obtained from the
 * GNU organization (www.gnu.org).
 * 
 */

#ifndef DI_CONFIG_H
#define DI_CONFIG_H

#include <di_endian.h>

// Version number:
#define DI_VERSION_MAJOR 0
#define DI_VERSION_MINOR 0
#define DI_VERSION_SUBMINOR 1

// Is our DIVA sample float or double:
#define DI_SAMPLE_IS_FLOAT 1

#if DI_SAMPLE_IS_FLOAT == 1
typedef float DI_Sample;
#define DI_ASF_SAMPLE DI_ASF_FLOAT32

#else 
typedef double DI_Sample;
#define DI_ASF_SAMPLE DI_ASF_FLOAT64

#endif


#endif
