/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */



#ifndef MJ_MESSAGE_MULTI2_H
#define MJ_MESSAGE_MULTI2_H

#include <mj_message_multi.h>

#include <qstring.h>

/** This class adds the possibility to query QStrings from the
    MJ_MessageMulti object. */

class MJ_MessageMulti2 : public MJ_MessageMulti
{
public:
  MJ_MessageMulti2() {}
  virtual ~MJ_MessageMulti2() {}

  virtual MJ_Message *duplicate();
  
  static MJ_Message *createNew();

  /// Gets a QString from the message
  QString getQString(const std::string &id, const char * def = 0);

};

#endif
