/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */


#ifndef MJ_MESSAGE_QIO_H
#define MJ_MESSAGE_QIO_H

class QTextStream;
class MJ_Message;

class MJ_MessageQio
{
public:

  static bool writeMsg(QTextStream *, MJ_Message *);
  static bool readMsg(QTextStream *, MJ_Message *, int);

  static bool writeMsgBool(QTextStream *, MJ_Message *);
  static bool readMsgBool(QTextStream *, MJ_Message *, int);

  static bool writeMsgDouble(QTextStream *, MJ_Message *);
  static bool readMsgDouble(QTextStream *, MJ_Message *, int);

  static bool writeMsgInt(QTextStream *, MJ_Message *);
  static bool readMsgInt(QTextStream *, MJ_Message *, int);

  static bool writeMsgMidi(QTextStream *, MJ_Message *);
  static bool readMsgMidi(QTextStream *, MJ_Message *, int);

  static bool writeMsgMulti(QTextStream *, MJ_Message *);
  static bool readMsgMulti(QTextStream *, MJ_Message *, int);

  static bool writeMsgStlString(QTextStream *, MJ_Message *);
  static bool readMsgStlString(QTextStream *, MJ_Message *, int);

  static bool writeMsgString(QTextStream *, MJ_Message *);
  static bool readMsgString(QTextStream *, MJ_Message *, int);

  static void writeCout(MJ_Message *);

  static MJ_Message *readFromStream(QTextStream *);

  static void initMessageFactory();

  static void testBufferIO();
};

#endif
