/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */


#ifndef MJ_MESSAGE_STRING_H
#define MJ_MESSAGE_STRING_H

#include <mj_message.h>

#include <qstring.h>

/// Qt-string message
class MJ_MessageString : public MJ_Message
{
public:

  MJ_MessageString(long time = -1) : MJ_Message(time) {}
  MJ_MessageString(const MJ_MessageString &);
  MJ_MessageString(const QString &);

  virtual ~MJ_MessageString() {}

  virtual MJ_MessageType messageType() const;
  virtual MJ_Message *duplicate();

  virtual double toDouble(bool *ok = 0);
  virtual int    toInt(bool *ok = 0);

  inline QString &string() { return m_string; }
  inline const QString &stringConst() const { return m_string; }
  inline void setString(const QString &s) { m_string = s.copy(); }

  virtual bool write2(DI_DataBuffer2 *b);
  virtual bool read2(DI_DataBuffer2 *b, int readFields);

  virtual std::string describe();

  static MJ_Message *createNew();
protected:

  QString m_string;
};

#endif
