/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_MODULE_RTAUDIO_H
#define MJ_MODULE_RTAUDIO_H

#include <mj_module_dsp.h>

/// Base class for real-time audio IO classes.
class MJ_ModuleRtAudio : public MJ_ModuleDsp
{
public:

  MJ_ModuleRtAudio();
  virtual ~MJ_ModuleRtAudio();

  /** The number of sample-frames to be played before buffer runs/ran
      dry. */
  virtual int  bufferLength();

  int minimumBuffer() const { return m_minimumBuffer;}
  void setMinimumBuffer(int bsize) { m_minimumBuffer = bsize;}

  int maximumBuffer() const { return m_maximumBuffer;}
  void setMaximumBuffer(int bsize) { m_maximumBuffer = bsize;}
  
protected:
  /// Shortest buffer period (=fragment size)
  int m_minimumBuffer;
  /// Maximum buffer length (=frament size * fragments)
  int m_maximumBuffer;
};

#endif
