/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */


#ifndef MJ_MODULE_STAND_ALONE_H
#define MJ_MODULE_STAND_ALONE_H

#include <mj_module_dsp_array.h>

/** Turn modules into applications.
    
    This class is used to turn normal DSP modules into stand-alone
    applications. For example one might not want to run a tuning meter
    inside a visible host, but in stand-alone mode. This class is used
    for that purpose. 
    
    This class automatically connects the audio inputs and otuputs of
    the module to computers input and output devices. */

class MJ_ModuleStandAlone : public MJ_ModuleDspArray
{
 public:
  MJ_ModuleStandAlone();
  virtual ~MJ_ModuleStandAlone();
  
  bool init(const QString & id);

 protected:

  MJ_ModuleDsp *m_audioIn;
  MJ_ModuleDsp *m_audioOut;
  MJ_ModuleDsp *m_module;
};

#endif
