/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_PIXMAP_LOADER_H
#define MJ_PIXMAP_LOADER_H


#include <qiconset.h>

/** A Utility class to load and cache pixmaps. The pixmaps are assumed
    to be located a standard directory: $MUSTAJUURI_PATH/icons/. This
    class prepends the requested icon name with the path and appends
    it with "proper" filetype suffix (".xpm", ".png"etc.).*/
class MJ_PixmapLoader
{
public:
  static QPixmap getPixmap(const QString &file);
  static QIconSet getIconSet(const QString &name, const QColor &bg);
  static void clear();
};

#endif
