/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_TIME_MONITOR_H
#define MJ_TIME_MONITOR_H

class MJ_CpuCount;
class QTime;

/// Measure CPU load.
class MJ_TimeMonitor
{
public:
  MJ_TimeMonitor();
  
  ~MJ_TimeMonitor();
  
  /** Update parameters. 

      You should not call update too frequently.
      Few times per second should be ok.
   */
  void update();

  /** The load caused during last measurement interval.
      
      Loads close to unity indicate 100 % CPU utilization.
   */
  inline float cpuLoad() { return M_fLoad; }

protected:
  
  MJ_CpuCount *M_xpCpuTime;
  QTime       *M_xpDateTime;
  /// Current load.
  float        M_fLoad;
};

#endif
