/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */


#ifndef MJ_VALUE_NUMERIC_TMPL_H
#define MJ_VALUE_NUMERIC_TMPL_H

#include <mj_value_numeric.h>

#include <mj_dom.h>

#include <iostream>
#include <typeinfo>

template <class T> 
MJ_ValueNumeric<T>::~MJ_ValueNumeric()
{}

template <class T> 
QDomElement MJ_ValueNumeric<T>::writeDom(QDomDocument & doc)
{
  QDomElement e = doc.createElement(m_id);
  
  MJ_addTextChild(e, doc, "value", QString::number(m_value));
  
  return e;
}

template <class T> 
bool MJ_ValueNumeric<T>::readDom(QDomElement &e)
{
  if(e.tagName() != m_id)
    return false;

  bool ok = true;

  m_value = MJ_get<T>(e, "value", m_value);

  // std::cout << typeid(*this).name() << " : " << m_value << std::endl;

  return ok;
}


#endif
