/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_message_numeric.h>

#include <stdio.h>

template <class TElem>
float MJ_MessageNumeric<TElem>::toFloat(bool *ok)
{
  (void) ok;
  return (float) m_value;
}

template <class TElem>
double MJ_MessageNumeric<TElem>::toDouble(bool *ok)
{
  (void) ok;
  return (double) m_value;
}

template <class TElem>
int MJ_MessageNumeric<TElem>::toInt(bool *ok)
{
  (void) ok;
  return (int) m_value;
}

template <class TElem>
long MJ_MessageNumeric<TElem>::toLong(bool *ok)
{
  (void) ok;
  return (long) m_value;
}


template <class TElem>
MJ_MessageType MJ_MessageNumeric<TElem>::messageType() const
{
  return MJ_MSG_EMPTY;
}


template <class TElem>
MJ_Message *MJ_MessageNumeric<TElem>::duplicate()
{
  return new MJ_MessageNumeric<TElem>(*this);
}

template <class TElem>
std::string MJ_MessageNumeric<TElem>::describe()
{
  std::string tmp;
  return tmp;
}

template <class TElem>
MJ_Message *MJ_MessageNumeric<TElem>::createNew()
{
  return new MJ_MessageNumeric<TElem>;
}
