/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_filter_iir.h>

/// Creates an empty filter.
template <class TElem>
MJ_FilterDFII<TElem>::MJ_FilterDFII()
  : m_val(0.0)
{}

/// Creates a filter of order "order".
template <class TElem>
MJ_FilterDFII<TElem>::MJ_FilterDFII(uint order)
  : m_val(0.0),
    m_coeffs(order),
    m_buffer(order ? order : 1)
{}

/** Clean up the filter. If the coefficient memory was allocated
    within this object the memory is freed. Ring buffer memory is
    always freed. */

template <class TElem>
MJ_FilterDFII<TElem>::~MJ_FilterDFII()
{}

