#import "ParticleForceDampingPatch.h"
#import "vee_damping.h"

@implementation ParticleForceDampingPatch

- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme Particle Force: Damping" forKey:@"name"];
	return at;
}


- (id)initWithIdentifier:(id)fp8
{
//	NSLog(@"ParticleForceDampingPatch::initWithIdentifier");
	self=[super initWithIdentifier:fp8];
	if(self)
	{
		[inputMagnitude setDoubleValue:1.0];
		[inputMagnitude setMinDoubleValue:-5.0];
		[inputMagnitude setMaxDoubleValue:5.0];
	}
	return self;
}


- (BOOL)setup:(QCOpenGLContext *)context
{
	[super setup:context];

//	NSLog(@"ParticleForceDampingPatch::setup");

	VEE_Damping *d=new VEE_Damping();
	d->setVisible(false);
	[_object setObject:d];

	return YES;
}
- (void)cleanup:(QCOpenGLContext *)context
{
	[super cleanup:context];

//	NSLog(@"ParticleForceDampingPatch::cleanup");
	// _object takes care of releasing our VEE_Vortex
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	[super execute:context time:time arguments:arguments];

//	NSLog(@"ParticleForceDampingPatch::execute");

	VEE_Damping *d=(VEE_Damping *)[_object object];

	if( [inputMagnitude wasUpdated] )
		d->setMagnitude( [inputMagnitude doubleValue] );

	return YES;
}

@end
