#import "ParticleForceGravityPatch.h"


@implementation ParticleForceGravityPatch

- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme Particle Force: Gravity" forKey:@"name"];
	return at;
}

- (id)initWithIdentifier:(id)fp8
{
//	NSLog(@"ParticleForceGravityPatch::initWithIdentifier");
	self=[super initWithIdentifier:fp8];
	if(self)
	{
		[inputGy setDoubleValue:-9.8];
	}
	return self;
}

- (BOOL)setup:(QCOpenGLContext *)context
{
	[super setup:context];

//	NSLog(@"ParticleForceGravityPatch::setup");

	VEE_Gravity *g=new VEE_Gravity();
	g->setVisible(false);
	[_object setObject:g];

	return YES;
}
- (void)cleanup:(QCOpenGLContext *)context
{
	[super cleanup:context];

//	NSLog(@"ParticleForceGravityPatch::cleanup");
	// _object takes care of releasing our VEE_Gravity
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	[super execute:context time:time arguments:arguments];

//	NSLog(@"ParticleForceGravityPatch::execute");

	VEE_Gravity *g=(VEE_Gravity *)[_object object];
	if(!g)
		return YES;

	{
		VEE_Vector3 l=*(g->gravity());
		if( [inputGx wasUpdated] )
			l.x=[inputGx doubleValue];
		if( [inputGy wasUpdated] )
			l.y=[inputGy doubleValue];
		if( [inputGz wasUpdated] )
			l.z=[inputGz doubleValue];
		g->setGravity(l);
	}

	return YES;
}

@end
