#import "ParticleOperatorNumberRandomPatch.h"

#import "vee_value_operator.h"


@implementation ParticleOperatorNumberRandomPatch

- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];

	// @@@ or is there some way we can easily retrieve this from the 'menu' key specified in the patch's xml file?
	NSString *typeString;
	switch( [inputType indexValue] )
	{
		case 0:
			typeString=@"Object Age Limit";
			break;
		case 1:
			typeString=@"Object Age";
			break;
		case 2:
			typeString=@"Object θ";
			break;
		case 3:
			typeString=@"Object ω";
			break;
		case 4:
			typeString=@"Object Size";
			break;
		case 5:
			typeString=@"Object Mass";
			break;
		case 6:
			typeString=@"Object Area";
			break;
		case 7:
			typeString=@"Emitter Rate";
			break;
		case 8:
			typeString=@"Emitter Max Child Count";
			break;
		case 9:
			typeString=@"Vortex ε";
			break;
		case 10:
			typeString=@"Vortex Range";
			break;
		case 11:
			typeString=@"Vortex Strength";
			break;
		case 12:
			typeString=@"Vortex Fade Range";
			break;
		case 13:
			typeString=@"Vortex Max Force";
			break;
		case 14:
			typeString=@"Vortex Radial Force";
			break;
		case 15:
			typeString=@"Vortex Min Radius";
			break;
		case 16:
			typeString=@"Damping Magnitude";
			break;
		case 17:
			typeString=@"Wind Strength";
			break;
		case 18:
			typeString=@"Wind Gust Strength";
			break;
		case 19:
			typeString=@"Wind Gust Frequency";
			break;
	}

	NSString *s=[NSString stringWithFormat:@"Kineme Particle Operator: Random %@",typeString];
	if( ![s isEqualToString:[at objectForKey:@"name"]] )
		[at setObject:s forKey:@"name"];

	return at;
}


- (id)initWithIdentifier:(id)fp8
{
//	NSLog(@"ParticleOperatorNumberRandomPatch::initWithIdentifier");
	self=[super initWithIdentifier:fp8];
	if(self)
	{
		[inputMax setDoubleValue:1.0];

		[inputType setMaxIndexValue:19];
	}
	return self;
}


- (BOOL)setup:(QCOpenGLContext *)context
{
	[super setup:context];

//	NSLog(@"ParticleOperatorNumberRandomPatch::setup");

	_vrf=new VEE_ValueRandomFloat;

	return YES;
}
- (void)cleanup:(QCOpenGLContext *)context
{
	[super cleanup:context];

//	NSLog(@"ParticleOperatorNumberRandomPatch::cleanup");

	delete _vrf;
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	[super execute:context time:time arguments:arguments];

//	NSLog(@"ParticleOperatorNumberRandomPatch::execute");

	VEE_ValueOperator *vop=[_op op];

	if(
		[inputMin wasUpdated]
		|| [inputMax wasUpdated]
	)
		_vrf->set
		(
			[inputMin doubleValue],
			[inputMax doubleValue]
		);

	// 'wasUpdated' is not used here --- we need to always ->set() again because the _vrf is clone()d.
	switch( [inputType indexValue] )
	{
		// clone()d because the ValueOperator->set() takes ownership of the ValueRandomFloat.
		case 0:
			vop->set("agelimit",_vrf->clone());
			break;
		case 1:
			vop->set("age",_vrf->clone());
			break;
		case 2:
			vop->set("rotation",_vrf->clone());
			break;
		case 3:
			vop->set("omega",_vrf->clone());
			break;
		case 4:
			vop->set("size",_vrf->clone());
			break;
		case 5:
			vop->set("mass",_vrf->clone());
			break;
		case 6:
			vop->set("area",_vrf->clone());
			break;
		case 7:
			vop->set("rate",_vrf->clone());
			break;
		case 8:
			vop->set("maxcount",_vrf->clone());
			break;
		case 9:
			vop->set("epsilon",_vrf->clone());
			break;
		case 10:
			vop->set("range",_vrf->clone());
			break;
		case 11:
			vop->set("strength",_vrf->clone());
			break;
		case 12:
			vop->set("faderange",_vrf->clone());
			break;
		case 13:
			vop->set("maxforce",_vrf->clone());
			break;
		case 14:
			vop->set("radialforce",_vrf->clone());
			break;
		case 15:
			vop->set("minradius",_vrf->clone());
			break;
		case 16:
			vop->set("magnitude",_vrf->clone());
			break;
		case 17:
			vop->set("strength",_vrf->clone());
			break;
		case 18:
			vop->set("gustiness",_vrf->clone());
			break;
		case 19:
			vop->set("gustfreq",_vrf->clone());
			break;
	}

	return YES;
}

@end
