#import "ParticleOperatorVectorImagePatch.h"

#import "QCImage.h"

#import "vee_value_vector_image.h"


@implementation ParticleOperatorVectorImagePatch

- (id)initWithIdentifier:(id)fp8
{
//	NSLog(@"ParticleOperatorVectorImagePatch::initWithIdentifier");
	self=[super initWithIdentifier:fp8];
	if(self)
		_operatorName=@"Image";
	return self;
}



- (BOOL)setup:(QCOpenGLContext *)context
{
	[super setup:context];

//	NSLog(@"ParticleOperatorVectorImagePatch::setup");

	_cs = CGColorSpaceCreateWithName(kCGColorSpaceGenericRGB);
	_pf = [QCPixelFormat pixelFormatBGRX8];
//	_pf = [QCPixelFormat pixelFormatIndexedGray8];

	_v=new VEE_ValueVectorImage;

	return YES;
}
- (void)cleanup:(QCOpenGLContext *)context
{
	[super cleanup:context];

//	NSLog(@"ParticleOperatorVectorImagePatch::cleanup");

	delete _v;
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
//	NSLog(@"ParticleOperatorVectorImagePatch::execute");

	VEE_ValueVectorImage *vrv=(VEE_ValueVectorImage *)_v;

	if( [inputImage wasUpdated] )
	{
		QCImage *im=[inputImage imageValue];
		
		QCImagePixelBuffer * pb = [im createPixelBufferForManager:[context imageManager] 
				withFormat: _pf
				bounds: [im bounds]
				colorSpace: _cs
				options:nil];

			vrv->setImage([im bounds].size.width,[im bounds].size.height,[pb baseAddress],[pb bytesPerRow]);
		

	}

	[super execute:context time:time arguments:arguments];

	return YES;
}

@end
