#import "ParticleParticlePatch.h"

#import "vee_render_class.h"

@implementation ParticleParticlePatch

- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme Particle" forKey:@"name"];
	return at;
}


- (id)initWithIdentifier:(id)fp8
{
//	NSLog(@"ParticleParticlePatch::initWithIdentifier");
	self=[super initWithIdentifier:fp8];
	if(self)
	{
		[inputAgeLimit setDoubleValue:10.0];

		[inputColor setRed:0.8 green:0.8 blue:1.0 alpha:0.5];
	}
	return self;
}


- (BOOL)setup:(QCOpenGLContext *)context
{
	[super setup:context];

//	NSLog(@"ParticleParticlePatch::setup");

	VEE_Particle2 *p=new VEE_Particle2();
	[_object setObject:p];

	return YES;
}
- (void)cleanup:(QCOpenGLContext *)context
{
	[super cleanup:context];

//	NSLog(@"ParticleParticlePatch::cleanup");
	// _object takes care of releasing our VEE_Particle2
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	[super execute:context time:time arguments:arguments];

//	NSLog(@"ParticleParticlePatch::execute");

	VEE_Particle2 *p=(VEE_Particle2 *)[_object object];

	if( [inputLooks wasUpdated] )
	{
		VEE_ValueLooks *looks=[[inputLooks looksValue] looks];
//		NSLog(@"ParticleParticlePatch::execute  Setting Looks to %08x",looks);
		p->setValue("looks",looks);

		// if the user has disconnected looks, reactivate the color
		if(!looks)
			p->setColor
			(
				VEE_Rgba
				(
					[inputColor redComponent],
					[inputColor greenComponent],
					[inputColor blueComponent],
					[inputColor alphaComponent]
				)
			);
	}

	if( [inputRenderClass wasUpdated] )
	{
		VEE_RenderClass *rc=[[inputRenderClass renderClassValue] renderClass];
//		NSLog(@"ParticleParticlePatch::execute  Setting Render Class to %08x",rc);
		p->setRenderClass(rc);
	}

	return YES;
}

@end
