#import "ParticleRenderClassPatch.h"

@implementation ParticleRenderClassPatch

+ (int)executionModeWithIdentifier:(id)fp8
{
	return 0;
}
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8
{
	return NO;
}
+ (int)timeModeWithIdentifier:(id)fp8
{
	return 0;
}


- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme Particle Render Class" forKey:@"name"];
	return at;
}


- (id)initWithIdentifier:(id)fp8
{
//	NSLog(@"ParticleRenderClassPatch::initWithIdentifier");
	self=[super initWithIdentifier:fp8];
	if(self)
	{
		[inputAlignment setIndexValue:2];
		[inputAlignment setMaxIndexValue:4];

		[inputLengthScale setDoubleValue:2.0];
		[inputLengthScale setMinDoubleValue:0.0];

		[inputMaxLengthScale setDoubleValue:4.0];
		[inputMaxLengthScale setMinDoubleValue:0.0];
	}
	return self;
}


- (BOOL)setup:(QCOpenGLContext *)context
{
//	NSLog(@"ParticleRenderClassPatch::setup");

	VEE_RenderClass *rc=new VEE_RenderClass();	
	_renderClass=[[ParticleRenderClass alloc] initWithRenderClass:rc];
	[outputRenderClass setRenderClassValue:_renderClass];

	return YES;
}

- (void)cleanup:(QCOpenGLContext *)context
{
//	NSLog(@"ParticleRenderClassPatch::cleanup");

	[_renderClass release];
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
//	NSLog(@"ParticleRenderClassPatch::execute");

	VEE_RenderClass *rc=[_renderClass renderClass];
	if( [inputAlignment wasUpdated] )
		rc->setAlign( (VEE_MotionAlign)[inputAlignment indexValue] );
	if( [inputLengthScale wasUpdated] )
		rc->setLengthScale( [inputLengthScale doubleValue] );
	if( [inputMaxLengthScale wasUpdated] )
		rc->setMaxLengthScale( [inputMaxLengthScale doubleValue] );

	return YES;
}

@end
