
/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_color_table.h>


VEE_Rgba VEE_RgbaTable::getScaled(float rel) 
{
  uint ncolors = m_colorTable.size();
  
  if(!ncolors)
    return VEE_Rgba::White;
  
  ncolors--;

  if(rel < 0.0f) rel = 0.0f;
  
  rel *= (float) ncolors;
  
  uint first = (uint) rel;
  
  if(first >= ncolors) {
    return m_colorTable[ncolors];
  }

  float tmp = rel - (float) first;
  return (m_colorTable[first] * (1.0 - tmp)) + (m_colorTable[first + 1] * tmp);
}
