/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_COLOR_TABLE_H
#define VEE_COLOR_TABLE_H

#include "di_types.h"
#include <vee_color.h>
#include <vector>

class VEE_RgbaTable
{
public:
  VEE_RgbaTable() {}
  ~VEE_RgbaTable() {}

  VEE_Rgba getScaled(float rel);

  void appendColor(const VEE_Rgba &v) { m_colorTable.push_back(v); }
  void appendColor2(float r, float g, float b, float a)
    { appendColor(VEE_Rgba(r, g, b, a)); }
  void popColor(void) { m_colorTable.pop_back(); }
  
  uint nofColors() const { return m_colorTable.size(); }

  const VEE_Rgba & getColor(uint i) const { return m_colorTable[i]; }
  void setColor(uint i, const VEE_Rgba &v) { m_colorTable[i] = v; }

  void clear() { m_colorTable.clear(); }

protected:

  std::vector<VEE_Rgba> m_colorTable;
};


#endif
