/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_ERROR_H
#define VEE_ERROR_H

#include <vee_config.h>

void VEE_setTraceStreamLock(void (*function)(bool));

void VEE_trace(const char *msg, ...);
void VEE_error(const char *msg, ...);
void VEE_fatal(const char *msg, ...);

#ifdef VEE_FAST

#define VEE_TRACE(x) 
#define VEE_ERROR(x) 
#define VEE_FATAL(x) 

#else

#define VEE_TRACE(x) VEE_trace(x)
#define VEE_ERROR(x) VEE_error(x)
#define VEE_FATAL(x) VEE_fatal(x)

#endif

#ifdef __sgi
#define VEE_FNAME static const char * fname = "__FILE__ __LINE__";
#else
#define VEE_FNAME static const char * fname = __FUNCTION__;
#endif

#endif
