/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_HAS_VALUES_H
#define VEE_HAS_VALUES_H

#include <vee_color.h> 
#include <vee_vector3.h> 
#include <vee_matrix3.h> 

class VEE_Value;

class VEE_HasValues
{
public:
  VEE_HasValues() {}
  virtual ~VEE_HasValues() {}

  virtual bool setValue(const char *, VEE_Value *);

  bool setValueInt(const char *, int);
  bool setValueFloat(const char *, float);
  bool setValueVector3(const char *, const VEE_Vector3 &);
  bool setValueVector3f(const char *, float , float , float);
  bool setValueMatrix3(const char *, const VEE_Matrix3 &);
  bool setValueRgba(const char *, const VEE_Rgba &);
  bool setValueRgbaf(const char *id, float r, float g, float b, float a)
  { return setValueRgba(id, VEE_Rgba(r, g, b, a)); }
  bool setValueRgbatf(const char *id, 
		      float r, float g, float b, float a, float t)
  { return setValueRgba(id, VEE_Rgba(r, g, b, a, t)); }

};

#endif
