/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_LOOKS_H
#define VEE_LOOKS_H

#include <vee_color.h>

class VEE_RgbaTable;
class VEE_Particle;

class VEE_Looks
{
public:
  VEE_Looks() : m_host(0) {}
  virtual ~VEE_Looks();
  virtual VEE_Rgba color();
  virtual VEE_Looks *clone() const = 0;

  void setHost(VEE_Particle *host) { m_host = host; }

protected:
  VEE_Particle *m_host;
};

#endif
