
/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_matrix2.h>
#include <vee_vector2.h>

#include <vee_matrix3.h>
#include <vee_vector3.h>

#include <vee_matrix4.h>
#include <vee_vector4.h>

const VEE_Vector2 VEE_Vector2ZERO(0.0f, 0.0f);
const VEE_Vector3 VEE_Vector3ZERO(0.0f, 0.0f, 0.0f);
const VEE_Vector4 VEE_Vector4ZERO(0.0f, 0.0f, 0.0f, 0.0f);

const VEE_Vector2 VEE_Vector2ONE(1.0f, 1.0f);
const VEE_Vector3 VEE_Vector3ONE(1.0f, 1.0f, 1.0f);
const VEE_Vector4 VEE_Vector4ONE(1.0f, 1.0f, 1.0f, 1.0f);

const VEE_Vector3 VEE_Vector3_UNIT_X(1, 0, 0);
const VEE_Vector3 VEE_Vector3_UNIT_Y(0, 1, 0);
const VEE_Vector3 VEE_Vector3_UNIT_Z(0, 0, 1);

const VEE_Matrix2 VEE_Matrix2IDENTITY(1.0f, 0.0f,
				      0.0f, 1.0f);

const VEE_Matrix3 VEE_Matrix3IDENTITY(1.0f, 0.0f, 0.0f,
				      0.0f, 1.0f, 0.0f,
				      0.0f, 0.0f, 1.0f);

const VEE_Matrix4 VEE_Matrix4IDENTITY(1.0f, 0.0f, 0.0f, 0.0f,
				      0.0f, 1.0f, 0.0f, 0.0f,
				      0.0f, 0.0f, 1.0f, 0.0f,
				      0.0f, 0.0f, 0.0f, 1.0f);
