/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_NEAR_OBJECTS_H
#define VEE_NEAR_OBJECTS_H

#include <vee_bounding_box.h>

class VEE_BoundingBox;
class VEE_SceneBox;

class VEE_NearObjects
{
public:
  VEE_NearObjects() {}
  ~VEE_NearObjects() {}
  
  long objectsInRange(const VEE_Vector3 &loc, float, VEE_SceneBox *);

protected:
  
  long objectsInRange2(VEE_SceneBox *); 

  VEE_Vector3     m_location;
  VEE_BoundingBox m_bbox;
  float           m_radiusSquared;
};

#endif
