/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_OPERATOR_DT_H
#define VEE_OPERATOR_DT_H

#include <vee_operator.h>

class VEE_OperatorDt : public VEE_Operator
{
public:
  VEE_OperatorDt(float addDt = 0.0, 
		 bool  moveBack = true, 
		 bool  resetAge = true,
		 float maxStep = 0.05)
    : m_dt(addDt), m_maxStep(maxStep), m_moveBack(moveBack), 
      m_resetAge(resetAge)  {}

  virtual ~VEE_OperatorDt();

  virtual bool setValue(const char *, VEE_Value *);

  virtual void operate(VEE_Object *, float);
  virtual VEE_Operator * clone() const;

  void set(float addDt, bool moveBack, bool resetAge)
  { m_dt = addDt; m_moveBack = moveBack; m_resetAge = resetAge; }

  void setMaxStep(float step) { m_maxStep = step; }

protected:
  float m_dt;
  float m_maxStep;
  bool  m_moveBack;
  bool  m_resetAge;
};

#endif
