/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_OPERATOR_FLASH_H
#define VEE_OPERATOR_FLASH_H

#include <vee_operator.h>

class VEE_OperatorFlash : public VEE_Operator
{
public:
  VEE_OperatorFlash();
  virtual ~VEE_OperatorFlash();

  virtual void operate(VEE_Object *, float);
  virtual VEE_Operator * clone() const;

  void set(float frequency, float minValue, float maxValue)
  { m_frequency = frequency; m_min = minValue; m_max = maxValue; }

protected:
  float m_frequency;
  float m_min, m_max;

};

#endif
