/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_OPERATOR_TEXTURE_LOOP_H
#define VEE_OPERATOR_TEXTURE_LOOP_H

#include <vee_operator.h>
#include <vee_reference_object.h>
#include <vee_value_curve.h>

#include <vector>

class VEE_OperatorTextureLoop : public VEE_Operator
{
public:
  VEE_OperatorTextureLoop();
  virtual ~VEE_OperatorTextureLoop();
  virtual void operate(VEE_Object *, float);
  virtual VEE_Operator * clone() const;

  void addTexture(int t);
  void setTimeScale(VEE_TimeScale scale) { m_timeScale = scale; }
  void setLoopTime(float time) { m_loopTime = time; }
    
protected:
  
  VEE_TimeScale m_timeScale;
  float         m_loopTime;
  float         m_time;
  VEE_ReferenceObject<std::vector<int> > m_textures;

};

#endif
