/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_operator_volume.h>

#include <vee_object.h>

VEE_OperatorVolume::VEE_OperatorVolume()
{}

VEE_OperatorVolume::~VEE_OperatorVolume()
{}

void VEE_OperatorVolume::setVolume(VEE_Volume * vol)
{ 
  m_volume = vol; 
}

bool VEE_OperatorVolume::setValue(const char *id, VEE_Value *v)
{
  if(strncmp(id, "volume/", 7) == 0 && m_volume.ptr())
    return m_volume.ptr()->setValue(id + 7, v);

  return false;
}

void VEE_OperatorVolume::operate (VEE_Object *obj, float)
{
  if(!m_volume.ptr() || !obj)
    return;

  VEE_Vector3 v = m_volume.ptr()->newRandomPoint();

  obj->setValueVector3(m_id.c_str(), v);
}

VEE_Operator* VEE_OperatorVolume::clone () const
{
  return new VEE_OperatorVolume(*this);
}
