
/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_parameter.h>

#include <vee_error.h>

#include <typeinfo>


VEE_Parameter * VEE_Parameter::clone() const
{
  VEE_fatal
    ("VEE_Parameter::clone # This method MUST be overridden (class %s)",
     typeid(*this).name());

  return 0;
}

bool VEE_Parameter::setValue(VEE_HasValues *)
{
  VEE_fatal
    ("VEE_Parameter::setValue # This method MUST be overridden (class %s)",
     typeid(*this).name());

  return false;
}
