/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_parameters.h>

#include <vee_error.h>
#include <vee_has_values.h>

VEE_Parameter * VEE_ParameterFloat::clone() const
{
  return new VEE_ParameterFloat(*this);
}

bool VEE_ParameterFloat::setValue(VEE_HasValues *o)
{
  if(!o) {
    VEE_fatal("VEE_ParameterFloat::setValue # NULL argument");
  }

  // VEE_trace("VEE_ParameterFloat::setValue # \"%s\" %p", m_name.c_str(), o);

  return o->setValueFloat(m_id.c_str(), m_value);
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

VEE_ParameterVector3::VEE_ParameterVector3()
{
  m_value.make(0.0f);
  m_bbox.low().make(0.0f);
  m_bbox.high().make(1.0f);
}

VEE_Parameter * VEE_ParameterVector3::clone() const
{
  return new VEE_ParameterVector3(*this);
}

bool VEE_ParameterVector3::setValue(VEE_HasValues *o)
{
  if(!o) {
    VEE_fatal("VEE_ParameterVector3::setValue # NULL argument");
  }

  // VEE_trace("VEE_ParameterVector3::setValue # \"%s\" %p", m_name.c_str(), o);

  return o->setValueVector3(m_id.c_str(), m_value);
}
