/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_RAND2D_H
#define VEE_RAND2D_H

#include <vee_operator.h>

#include <mj_array2d.h>

#include <string>

class VEE_RandOnMesh2D : public VEE_Operator
{
public:
  VEE_RandOnMesh2D();
  virtual ~VEE_RandOnMesh2D();

  virtual bool setValue(const char *, VEE_Value *);

  virtual void operate(VEE_Object *, float);
  virtual VEE_Operator * clone() const;

  void resize(int rows, int cols) { m_histogram.resize(rows, cols); }
  void clear() { m_histogram.setAll(0.0); }
  void setDecay(float d) { m_decay = d; }
  void setThreshold(float t) { m_threshold = t; }

  void setId(const char *id) { m_id = id; }

  VEE_Vector3 newVector();

protected:
  MJ_Array2D<float> m_histogram;

  VEE_Matrix3 m_align;
  VEE_Vector3 m_stretch;

  float m_decay;
  float m_threshold;

  std::string m_id;
};

#endif
