/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_random.h>

static unsigned VEE_UniformRandCount = 0;

VEE_RandomUniform VEE_rand;

VEE_RandomUniform::VEE_RandomUniform()
  : m_val(++VEE_UniformRandCount)
{}
  
VEE_RandomUniform::~VEE_RandomUniform()
{}

float VEE_RandomUniform::rand()
{
  unsigned tmp = m_val * m_randMul + 1;
  m_val = tmp;
  return (float) tmp * (2.0 / (float) ((unsigned) 0xffffffff)) - 1.0;
}

VEE_Random * VEE_RandomUniform::clone()
{
  return new VEE_RandomUniform(*this);
}
