/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_RATE_CONTROL_H
#define VEE_RATE_CONTROL_H

#include <vee_operator.h>

#include <string>

class VEE_RateControl : public VEE_Operator
{
public:
  VEE_RateControl();
  virtual ~VEE_RateControl();

  void defaults();

  virtual void operate(VEE_Object *, float);
  virtual VEE_Operator * clone() const;

  void setId(const char *id) { m_param = id; }

  void setRadius(float r) { m_radius = r; }
  void setHeat(float h)   { m_heat = h; }
  void setHeatCoeff(float c) { m_heatCoeff = c; }
  void setRequireHeat(float r) { m_requireHeat = r; }
  void setMaxRate(float r) { m_maxRate = r; }
  void dieAfter(float d) { m_dieAfter = d; } 
protected:

  std::string m_param;

  float m_rateIntegral;
  float m_dieAfter;
  float m_rateToHeat;
  float m_currentRate;
  float m_maxRate;
  float m_maxHeat;
  float m_requireHeat;
  float m_heatCoeff;
  float m_heat;
  float m_radius;
};

#endif
