/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_RENDER_CLASS_H
#define VEE_RENDER_CLASS_H

enum VEE_MotionAlign {
  VEE_ALIGN_BILLBOARD,
  VEE_ALIGN_MOTION_TOTAL,
  VEE_ALIGN_MOTION_TEXTURE,
  VEE_ALIGN_MOTION_SHEAR,
  VEE_ALIGN_FIXED,
  VEE_ALIGN_SIZEOF
};

/** Describes how particles of particular type should be rendered. */
class VEE_RenderClass
{
public:
  VEE_RenderClass();
  ~VEE_RenderClass();

  void defaults();

  float lengthScale() const { return m_lengthScale; }
  void  setLengthScale(float scale) { m_lengthScale = scale; }
  float maxLengthScale() const { return m_maxLengthScale; }
  void  setMaxLengthScale(float scale) { m_maxLengthScale = scale; }
  
  VEE_MotionAlign align() const { return m_align; }
  void setAlign(VEE_MotionAlign a) { m_align = a; }

  void nextAlignMent() 
  { m_align = (VEE_MotionAlign) ((int) (m_align + 1) % VEE_ALIGN_SIZEOF); }

  int shader() const { return m_shader; }
  void setShader(int shader) { m_shader = shader; }
protected:
  int   m_shader;
  float m_lengthScale;
  float m_maxLengthScale;
  
  VEE_MotionAlign m_align;

};

#endif
