/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_TUBE_H
#define VEE_TUBE_H

#include  <vee_force_object.h>

class VEE_Tube : public VEE_ForceObject
{
public:
  VEE_Tube();
  virtual ~VEE_Tube();

  virtual bool setValue(const char *, VEE_Value *);
  virtual VEE_Variable getVariable(const char *) const;
  virtual VEE_Object * clone() const;

  void getForce(VEE_Vector3 *force,
		const VEE_Vector3 &velocity,
                const VEE_Vector3 &location);

  void boundingBoxOfForce(VEE_BoundingBox *box);

  static VEE_Object * factory();

  float height() const { return m_height; }
  float radius() const { return m_radius; }

  const VEE_Matrix3 & rotation() { return m_rotation; }  

protected:

  float       m_height;
  float       m_radius;
  float       m_effectRange;
  float       m_magnitude;

  VEE_Matrix3 m_rotation;
  VEE_Matrix3 m_rotationInv;
};

#endif
