/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_value.h>

#include <vee_error.h>

#include <typeinfo>

VEE_Value * VEE_Value::clone() const
{
  VEE_fatal
    ("VEE_Operator::clone # This method MUST be overridden (class %s)",
     typeid(*this).name());

  return 0;
}

/// Tries to get a float from the value
bool VEE_Value::getFloat(float *)
{ 
  return false; 
}

/// Tries to get a int from the value
bool VEE_Value::getInt(int *)
{ 
  return false; 
}

/// Tries to get a vector from the value
bool VEE_Value::getVector3(VEE_Vector3 *)
{ 
  return false; 
}

/// Tries to get a matrix from the value
bool VEE_Value::getMatrix3(VEE_Matrix3 *)
{
  return false;
}

bool VEE_Value::getFloat2(bool & checked, 
			 const char *c1, const char *c2, float *ptr)
{
  if(checked) return true;

  if(strcmp(c1, c2) != 0)
    return false;
  
  checked = true;
  return getFloat(ptr);
}

bool VEE_Value::getInt2(bool & checked, 
		       const char *c1, const char *c2, int *ptr)
{
  if(checked) return true;

  if(strcmp(c1, c2) != 0)
    return false;
  
  checked = true;
  return getInt(ptr);
}

