/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_VALUE_OPERATOR_H
#define VEE_VALUE_OPERATOR_H

#include <vee_matrix3.h>
#include <vee_operator.h>
#include <vee_vector3.h>

#include <string>

class VEE_Value;
class VEE_Object;

/** Carries one value to an object. */
class VEE_ValueOperator : public VEE_Operator
{
public:
  VEE_ValueOperator();
  VEE_ValueOperator(const VEE_ValueOperator & );

  VEE_ValueOperator(const std::string &, float);
  VEE_ValueOperator(const std::string &, const VEE_Matrix3 &);
  VEE_ValueOperator(const std::string &, const VEE_Vector3 &);

  virtual ~VEE_ValueOperator();

  virtual void operate(VEE_Object *);

  void set(const std::string &, VEE_Value *);

  VEE_ValueOperator & operator = (const VEE_ValueOperator &);

protected:
  VEE_Value * m_value;
  std::string m_id;
};


#endif
