/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_VALUE_OBJECT_H
#define VEE_VALUE_OBJECT_H

#include <vee_value.h>

class VEE_Object;

class VEE_ValueObject : public VEE_Value
{
public:
  VEE_ValueObject(VEE_Object *obj = 0);

  virtual ~VEE_ValueObject();

  virtual VEE_Value * clone() const;

  VEE_Object *newObject();
  VEE_Object *getObject();

protected:
  VEE_Object *m_obj;
};

#endif
