/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_VALUE_STR_H
#define VEE_VALUE_STR_H

#include <vee_value.h>

#include <string>

/// Value that carries one floating point number.
class VEE_ValueString : public VEE_Value
{
public:
  VEE_ValueString();
  VEE_ValueString(const std::string & s) : m_string(s) {}
  virtual ~VEE_ValueString();

  virtual VEE_Value * clone() const;

  virtual bool getFloat(float *);
  virtual bool getInt(int *);
  virtual bool getVector3(VEE_Vector3 *);
  virtual bool getMatrix3(VEE_Matrix3 *);

  const std::string & string() const { return m_string; }
  void setString(const std::string & s) { m_string = s; }

protected:
  std::string m_string;
};

#endif
