/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_VOLUME_SPHERE_H
#define VEE_VOLUME_SPHERE_H

#include <vee_volume.h>

class VEE_VolumeSphere : public VEE_Volume
{
public:
  VEE_VolumeSphere();

  VEE_VolumeSphere(float innerRadius, float outerRadius)
    : m_innerRadius(innerRadius), m_outerRadius(outerRadius) {}

  virtual ~VEE_VolumeSphere();

  virtual float inside(const VEE_Vector3 &);
  virtual void getBoundingBox(VEE_BoundingBox *);

  virtual VEE_Volume * clone() const;

  void set(float inner, float outer)
  { m_innerRadius = inner; m_outerRadius = outer; }

  float innerRadius() const { return m_innerRadius; }
  float outerRadius() const { return m_outerRadius; }

protected:

  float m_innerRadius;
  float m_outerRadius;

};

#endif
