#include "Grid.hpp"

#include "Geom.hpp"

// #include "Ray.hpp"

Grid3::Grid3(int n, const Vector3& min, const Vector3& max)
  :gmin(min),gmax(max),n(n)
{
  cells = new Cell[n*n*n];
  cellSize = (gmax-gmin)/(double)n;
}

void Grid3::rasterizeTriangle(const Vector3& v1, const Vector3& v2, const Vector3& v3, int i)
{
  Vector3i g[3];
  g[0] = getGridCoords(v1);
  g[1] = getGridCoords(v2);
  g[2] = getGridCoords(v3);

  Vector3i min,max;
  getBoundingBox(min,max,g,3);

  for(int x = min.x; x <= max.x; x++)
	for(int y = min.y; y <= max.y; y++)
	  for(int z = min.z; z <= max.z; z++)
		{
		  Vector3 cellmin = getCoords(Vector3i(x,y,z));
		  Vector3 cellmax = getCoords(Vector3i(x+1,y+1,z+1));
		  if(intersectTriangleAABox(v1,v2,v3,cellmin,cellmax))
			getCell(Vector3i(x,y,z)).addTriangle(i);
		} 
}

/*
void Grid3::initCellWalk(const Ray& ray)
{
  Vector3 p = ray.origin;
  Vector3 d = ray.direction;
  d.descale(cellSize);
  traverser.init((p-gmin).descale(cellSize),d);
}
*/
