/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_MESH_CONVERSION_H
#define VEE_MESH_CONVERSION_H


namespace Solar {

  class GraphicTriangles;
}

class VEE_MarchingCubes;
class VEE_VolumeGrid2;

/** This class contains functions to convert polygon meshes from one
    representation to another. */

class VEE_MeshConversion
{
public:
  static void append(Solar::GraphicTriangles * target,
		     const VEE_MarchingCubes * source,
		     float uvScale = 1.0);
  static void append(Solar::GraphicTriangles * target,
		     const VEE_VolumeGrid2   * source,
		     float uvScale = 1.0);
  
};


#endif
