/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_RIGID_PARTICLE_H
#define VEE_RIGID_PARTICLE_H

#include <vee_particle2.h>

/** A particle that is represented by a non-deforming polygon mesh. */

class VEE_RigidParticle : public VEE_Particle2
{
public:
  VEE_RigidParticle();
  virtual ~VEE_RigidParticle();
  
  virtual bool setValue(const char *, VEE_Value *);
  virtual VEE_Object *clone() const;

  int mesh() const { return m_mesh; }
  const VEE_Vector3 & rotationAxis() const { return m_rotationAxis; }

protected:
  int         m_mesh;
  VEE_Vector3 m_rotationAxis;
};

#endif
