/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_CONTAINMENT_H
#define GEE_CONTAINMENT_H

#include <gee_bounded.h>

#include <vee_vector3.h>

class GEE_Geometry;

class GEE_SimpleTriangle
{
public:
  VEE_Vector3 m_vertices[3];
};


class GEE_Containment : public GEE_Bounded
{
public:

  GEE_Containment() {}
  virtual ~GEE_Containment() {}

  virtual bool contains(const VEE_Vector3 &) = 0;
  virtual bool intersects(const GEE_SimpleTriangle &) = 0;
  virtual void contained(GEE_Geometry *);
};

class GEE_ContainAll : public GEE_Containment
{
public:
  GEE_ContainAll() {}
  virtual ~GEE_ContainAll();

  virtual void getBoundingBox(VEE_BoundingBox *);
  virtual bool contains(const VEE_Vector3 &);
  virtual bool intersects(const GEE_SimpleTriangle &);
};

#endif
