/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_ID_SELECT_H
#define GEE_ID_SELECT_H

#include <gee_operator.h>

#include <set>

class GEE_IdSelect : public GEE_Operator
{
public:

  GEE_IdSelect();
  virtual ~GEE_IdSelect();

  virtual id_container * getExtraIds();
  virtual bool act(GEE_World *, const GEE_TimeStamp &);

  virtual bool read(GEE_Io *);
  virtual bool write(GEE_Io *);
  virtual const char * type();
  static GEE_Operator * create();

  void addId(GEE_id_t id) { m_ids.insert(id); }

protected:
  id_container m_ids;

};

#endif
