/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_INSERT_PARTICLE_H
#define CRYSTAL_INSERT_PARTICLE_H

#include <gee_operator.h>
#include <gee_param_writer.h>
#include <gee_particle_object.h>

/** Inserts a single particle to the world. The particle is stored
 * into a GEE_ParticleObject that contains exactly one particle. */

class GEE_InsertParticle : public GEE_Operator
{
public:
  GEE_InsertParticle();
  virtual ~GEE_InsertParticle();
  
  virtual bool act(GEE_World *, const GEE_TimeStamp &);

  virtual bool read(GEE_Io *);
  virtual bool write(GEE_Io *);
  virtual const char * type();

  static GEE_Operator * create();

  GEE_ParticleData & particle() { return m_particle; }

protected:
  GEE_ParticleData m_particle;

  GEE_ParamWriter  m_writer;

  GEE_id_t         m_objId;
};

#endif
