/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_PATH_INSERT_H
#define GEE_PATH_INSERT_H

#include <gee_operator.h>

#include <gee_path.h>

class GEE_PathInsert : public GEE_Operator
{
public:
  GEE_PathInsert(GEE_id_t id = -1);
  virtual ~GEE_PathInsert();

  virtual bool act(GEE_World *, const GEE_TimeStamp &);

  virtual bool read(GEE_Io *);
  virtual bool write(GEE_Io *);
  virtual const char * type() { return "GEE_PathInsert"; }

  GEE_Path3D & path() { return m_path; }

  static GEE_Operator * create();

  void setPathId(GEE_id_t id) { m_pathId = id; }
  GEE_id_t pathId() const { return m_pathId; }
protected:

  GEE_id_t   m_pathId;
  GEE_Path3D m_path;
};

#endif
