/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <gee_sphere.h>

#include <gee_renderer.h>

#include <vee_bounding_box.h>

GEE_Sphere::GEE_Sphere()
  : m_radius(1.0)
{}

GEE_Sphere::~GEE_Sphere()
{}

void GEE_Sphere::render(GEE_Renderer *r)
{
  r->pushTransform(transformation());
  r->renderSphere(this);
  r->popTransform();
}

bool GEE_Sphere::getBoundingBox(VEE_BoundingBox *b)
{
  b->set(VEE_Vector3(0,0,0), m_radius);
  return true;
}
