/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_SPHERE_H
#define GEE_SPHERE_H

#include <gee_geometry.h>

/** A sphere geometry. This class is mainly used to display tools and
    their size - not for real modeling.

    @author Tommi Ilmonen
*/
class GEE_Sphere : public GEE_Geometry
{
public:
  GEE_Sphere();
  virtual ~GEE_Sphere();

  virtual void render(GEE_Renderer *);
  virtual bool getBoundingBox(VEE_BoundingBox *);

  float radius() const { return m_radius; }
  void setRadius(float r) { m_radius = r; }

protected:

  float       m_radius;
};

#endif
