/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <gee_transformation.h>

#include <gee_renderer.h>

GEE_Transformation::GEE_Transformation() 
  : m_child(0) 
{ 
  m_transformation.identity(); 
}

GEE_Transformation::~GEE_Transformation()
{}


GEE_Geometry * GEE_Transformation::clone() const
{
  return new GEE_Transformation(*this);
}

GEE_Geometry * GEE_Transformation::removeData(const VEE_Vector3 &loc, float radius)
{
  return 0;
}

void GEE_Transformation::render(GEE_Renderer *r)
{
  GEE_Geometry *child = m_child.ptr();

  if(!child)
    return;

  r->pushTransform(m_transformation);
  child->render(r);
  r->popTransform();
}

bool GEE_Transformation::getBoundingBox(VEE_BoundingBox *)
{
  return false;
}

bool GEE_Transformation::move(const VEE_Vector3 & offset)
{
  GEE_Geometry *child = m_child.ptr();

  if(!child)
    return false;
  
  return child->move(offset);
}
