///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 *	Contains axes definition.
 *	\file		IceAxes.h
 *	\author		Pierre Terdiman
 *	\date		January, 29, 2000
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include Guard
#ifndef __ICEAXES_H__
#define __ICEAXES_H__

enum PointComponent	
  {
    _ICE_X					= 0,
    _ICE_Y					= 1,
    _ICE_Z					= 2,
    _ICE_W					= 3,
    
    _FORCE_DWORD		= 0x7fffffff
  };

enum AxisOrder
  {
    AXES_ICE_XYZ			= (_ICE_X)|(_ICE_Y<<2)|(_ICE_Z<<4),
    AXES_ICE_XZY			= (_ICE_X)|(_ICE_Z<<2)|(_ICE_Y<<4),
    AXES_ICE_YXZ			= (_ICE_Y)|(_ICE_X<<2)|(_ICE_Z<<4),
    AXES_ICE_YZX			= (_ICE_Y)|(_ICE_Z<<2)|(_ICE_X<<4),
    AXES_ICE_ZXY			= (_ICE_Z)|(_ICE_X<<2)|(_ICE_Y<<4),
    AXES_ICE_ZYX			= (_ICE_Z)|(_ICE_Y<<2)|(_ICE_X<<4),

    AXES_FORCE_DWORD	= 0x7fffffff
  };

class ICEMATHS_API Axes
{
public:

  inline_			Axes(AxisOrder order)
  {
    mAxis0 = (order   ) & 3;
    mAxis1 = (order>>2) & 3;
    mAxis2 = (order>>4) & 3;
  }
  inline_			~Axes()		{}

  udword	mAxis0;
  udword	mAxis1;
  udword	mAxis2;
};

#endif // __ICEAXES_H__
