
/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_gl_material.h>

VEE_GlMaterial VEE_GlMaterialBank::m_default;

void VEE_GlMaterialBank::addMaterial(int name, 
				     const VEE_GlMaterial &material)
{
  // trace("VEE_GlMaterialBank::addMaterial # \"%s\"", name.c_str());
  m_materials[name] = material;
}

/** Gets a material by name. If the material is not found, then the
    default material is returned. */

const VEE_GlMaterial & VEE_GlMaterialBank::getMaterial(int s)
{

  std::map<int, VEE_GlMaterial>::iterator it = m_materials.find(s);

  if(it != m_materials.end()) {
    // trace("VEE_GlMaterialBank::getMaterial # \"%s\"", s.c_str());
    return (*it).second;
  }

  return m_default;
}
