# Cow-particle collisions with Opcode.

# Usual initializations:

from vee_init import *
from vee import *
import math

qa = QApplication_newApp()
scene = VEE_SceneBox()
VEE_ObjectFactory_init()

vq = VEE_Qt(scene)
# Make force invisible:
# q2 = VEE_TestQt(vq, scene, "", 640, 480, vq)
# vq.setGlWidget(q2);

vq.getGlWidget().setAutoRewind(0);
world = vq.getGlWidget().geeEngine().world();

agelimit = 5.0
gravity = 5.0

# object = "cat.lwo";
# object = "/usr/share/Performer/data/cow.obj";
object = "cow.obj";
# object = "cupbase.lwo";
# object = "/usr/share/Performer/data/teapot.dxf";
objectscale = 1.0;

collider = VEE_OpcodeCollision()

collider.loadModel(object)

scene.addNewObject(collider)

group = GEE_Group();
group.thisown = 0
world.addGeometry(group)
# g.loadModel("/usr/share/Performer/data/dumptruck.obj");
group.loadModel(object);
# g.loadModel("hakkyra.obj");

#trans = VEE_Vector4d()
#trans.make(0.0, 0.0, 0.0, 1.0)
#mat = VEE_Matrix4d()
#mat.identity()
#mat.addToColumn(3, trans);

# group.setTransformation(mat)


#############################################################################

# Build a particle with nice colors, lifespan etc:

p = VEE_Particle()
# p = VEE_TailParticle()
p.thisown = 0

#############################################################################

# Now for the flame creator
creator =  VEE_Emitter(p)
creator.thisown = 0;

v1 = VEE_Vector3()
v2 = VEE_Vector3()

range = 0.2

v1.make(-range, -0.5 * range , -range)
v2.make( range,  0.5 * range,  range)

rv = VEE_ValueRandomVector3()

rv.setRanges(v1, v2)

vo = VEE_ValueOperator()

vo.set("addvelocity", rv.clone())

creator.appendOperator(vo.clone())

vo.set("addlocation", rv.clone())
creator.appendOperator(vo.clone())

rf = VEE_ValueRandomFloat()
rf.set(0.5, 1.0)

vo.set("mass", rf.clone())
creator.appendOperator(vo.clone())

scene.addNewObject(creator)

#############################################################################

# Create a few forces:

g = VEE_ObjectFactory_create("gravity")
scene.addNewObject(g)
g.setValueInt("visible", 0);


#############################################################################

# Make GUI mappings for a couple a few parameters:

paramView = VEE_ValueWindow()

paramView.addFloatParameter("Gravity", "gravity", g, -13, -20.0, 20.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Grid bounciness", "bounce", collider,
                            0.5, 0.0, 1.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Grid drag", "drag", collider,
                            0.0, 0.0, 1.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Flame agelimit", "agelimit", p, 1.1, .5, 10.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Flame rate", "rate", creator, 500.0, 0.0, 1500.0,
                            VEE_MAP_LINEAR);

paramView.addVector3Parameter("Flame location", "location", creator,
                              1.0, -7.0, 7.0,
                              3.0, -3.0, 7.0,
                              0.0, -7.0, 7.0);

#############################################################################

# Make it visible:

# q2.setMtlFile("vee_materials.mtl");

vq.toggleForceMode();
qa.setMainWidget(vq)
vq.show()
# vq.setRenderOrder("1");
vq.setValueFloat("GL/size", 0.04);
vq.setValueInt("GL/subtexture", 5);

vq.setFrameFile("frames/cow-%.5d.jpg")

kp = vq.addKeyPoint2(-0.000, 1.090, 3.762, 3.142, -0.300);
vq.selectKeyPoint2(kp);

paramView.bangValues()

paramView.show()

qa.execute()

