# Cool exlposions

# Usual initializations:
from vee_init import *
from vee import *

qa = QApplication_newApp()
scene = VEE_SceneBox()
VEE_ObjectFactory_init()


v1 = VEE_Vector3()
v2 = VEE_Vector3()

#############################################################################


p = VEE_Particle()
p.thisown = 0

p.setAgeLimit(3.0)

rgbatable = VEE_RgbaTable()
color = VEE_Rgba()

color.set(0.5, 0.3, 0.0, 1.0)
rgbatable.appendColor(color)
color.set(0.7, 0.7, 0.3, 1.0)
rgbatable.appendColor(color)
color.set(0.3, 0.3, 0.3, 1.0)
rgbatable.appendColor(color)
color.set(0.0, 0.0, 0.0, 0.0)
rgbatable.appendColor(color)

looks = VEE_LooksColorTable(rgbatable)
looks.thisown = 0

valueLooks = VEE_ValueLooks()
valueLooks.setLooks(looks)

p.setValue("looks", valueLooks)

creator =  VEE_Emitter(p)
creator.thisown = 0;


v1.make(-4.0, 9.0, -4.0)
v2.make(4.0, 0.0, 4.0)

rv = VEE_ValueRandomVector3()

rv.setRanges(v1, v2)

vo = VEE_ValueOperator()

vo.set("addvelocity", rv.clone())

creator.appendOperator(vo.clone())

vo.set("addlocation", rv.clone())
creator.appendOperator(vo.clone())

creator.setRate(5);

scene.addNewObject(creator)

n = 1600

# Create n particles
for i in range(0,n):
    creator.setValueInt("trigger", 0)

# Now we change the looks of the particle

rgbatable2 = VEE_RgbaTable();
rgbatable2.appendColor2(1.0, 0.0, 0.0, 1.0);
# rgbatable2.appendColor2(1.0, 0.3, 0.3, 1.0);
rgbatable2.appendColor2(1.0, 0.5, 0.1, 1.0);
rgbatable2.appendColor2(0.3, 0.3, 0.1, 1.0);
rgbatable2.appendColor2(0.0, 0.0, 0.0, 0.0);

looks = VEE_LooksColorTable(rgbatable2)
looks.thisown = 0

valueLooks = VEE_ValueLooks()
valueLooks.setLooks(looks)

p.setValue("looks", valueLooks)

n = 1000
delay = 1.6

rateCurve = VEE_ValueCurve2()
rateCurve.setScaling(VEE_TS_LINEAR)
rateCurve.appendPoint(n / 8, 0.0)
rateCurve.appendPoint(n / 8, delay)
rateCurve.appendPoint(n, delay + 0.4)
rateCurve.appendPoint(n, delay + 0.7)
rateCurve.appendPoint(n / 8, delay + 0.9)
rateCurve.appendPoint(0.0, delay + 3.0)
rateCurve.setId("rate");
rateCurve.scaleTimes(1.5);

rf = VEE_ValueRandomFloat()
rf.set(1.5, 3.0)

vo = VEE_ValueOperator()
vo.set("agelimit", rf.clone())

creator.appendSelfOperator(rateCurve.clone());
creator.appendOperator(vo.clone());

#############################################################################


# Create a vortex generator:

vortex = VEE_ObjectFactory_create("vortex")
vortex.thisown = 0
vortex.setAgeLimit(3.5);
vortex.setValueFloat("range", 5.0);
vortex.setValueFloat("magnitude", 5);
vortex.setValueFloat("maxforce", 25);
vortex.setValueFloat("gravitate", 1.0);
vortex.setValueFloat("mass", 1.1);
vortex.setValueFloat("area", 1.1);
vortex.setVelocityUpdate(1)

rangeMax = 7.0

rangeCurve = VEE_ValueCurve2()
rangeCurve.setId("range");
rangeCurve.appendPoint(rangeMax / 5, 0.0);
rangeCurve.appendPoint(rangeMax, 1.0);
rangeCurve.appendPoint(rangeMax * 0.6, 2.0);
rangeCurve.setScaling(VEE_TS_LINEAR)

vortexRef = VEE_Particle2_cast(vortex);
vortexRef.appendSelfOperator(rangeCurve.clone());

screator = VEE_Emitter(vortex)
screator.thisown = 0;

# Random direction:
vo.set("axes", rv.clone())
screator.appendOperator(vo.clone())
# Randomize location:
r = 5;

v1.make(-r, 2 * r, -r)
v2.make(r, 0.0, r)
rv.setRanges(v1, v2)
vo.set("addlocation", rv.clone())
screator.appendOperator(vo.clone())
screator.appendOperator(vo.clone())
screator.setRate(9.0);

scene.addNewObject(screator)

n = 30

for i in range(0,n):
    screator.setValueInt("trigger", 0)

#############################################################################
#############################################################################

vortex2 = VEE_ObjectFactory_create("vortex")
vortex2.thisown = 0
vortex2.setAgeLimit(2.5);
vortex2.setValueFloat("range", 15.0);
vortex2.setValueFloat("magnitude", 5.0);
vortex2.setValueFloat("maxforce", 1.5);
vortex2.setValueFloat("gravitate", -2.0);
vortex2.setValueFloat("mass", 1.0);
vortex2.setValueFloat("area", 1.0);
vortex2.setVelocityUpdate(1)

rangeMax = 8.0

rangeCurve = VEE_ValueCurve2()
rangeCurve.setId("range");
rangeCurve.appendPoint(rangeMax / 3, 0.0);
rangeCurve.appendPoint(rangeMax, 1.0);
rangeCurve.appendPoint(rangeMax * 0.6, 2.0);
rangeCurve.setScaling(VEE_TS_LINEAR)

vortexRef2 = VEE_Particle2_cast(vortex2);
vortexRef2.appendSelfOperator(rangeCurve.clone());

screator2 = VEE_Emitter(vortex2)
screator2.thisown = 0;

# Random direction:
vo.set("axes", rv.clone())
screator2.appendOperator(vo.clone())
# Randomize location:
r = 5;

v1.make(-r, 2 * r, -r)
v2.make(r, 0.0, r)
rv.setRanges(v1, v2)
vo.set("addlocation", rv.clone())
screator2.appendOperator(vo.clone())
screator2.setRate(2.0);

scene.addNewObject(screator2)

n = 10

for i in range(0,n):
    screator2.setValueInt("trigger", 0)




#############################################################################

explosion = VEE_ObjectFactory_create("explosion")

explosion.setAgeLimit(1.0)
explosion.setValueFloat("magnitude", 100.0)
explosion.setValueFloat("range", 5.0)

# explosion.setLocation3(0.0, 0.0, 0.0);

ecreator = VEE_Emitter(explosion.clone());
ecreator.setRate(0.5)

# rangeCurve = VEE_ValueCurve2()
# rangeCurve.setId("trigger");
# rangeCurve.appendPoint(0.0, 0.0);
# rangeCurve.appendPoint(0.0, 2.0);

scene.addNewObject(ecreator)

#############################################################################

g = VEE_ObjectFactory_create("gravity")
g.setValueVector3f("gravity", 0.0, -5.0, 0.0);
scene.addNewObject(g)

#############################################################################

damp = VEE_ObjectFactory_create("damping")
damp.setValueFloat("magnitude", 1.0);
scene.addNewObject(damp)

#############################################################################

plane = VEE_ObjectFactory_create("forceplane")
scene.addNewObject(plane)

plane.setValueFloat("magnitude", 100.0);
plane.setValueFloat("range", .5);
plane.setValueFloat("radius", 1000.0);
plane.setLocation3(0.0, -1.0, 0.0);

#############################################################################

repel = VEE_ObjectFactory_create("gravitate")
scene.addNewObject(repel)

repel.setValueFloat("range", 15.0)
repel.setValueFloat("magnitude", -100.0)
repel.setValueFloat("decaypower", 0.5)

repel.setLocation3(0.0, -0.5, 0.0)

#############################################################################

vq = VEE_Qt(scene)

# vq.setValueFloat("speed", 1.0)
vq.setValueFloat("speed", 1.0)
vq.setValueFloat("maxrecursion", 4)

vq.setValueFloat("GL/size", 3.7)
# vq.setValueInt("GL/blendtype", 2)
vq.setValueFloat("GL/alphamul", 0.2)
vq.setValueFloat("GL/lengthscale", 0.15)

gl = vq.renderer();
gl.setCameraPosition3f(0.0, 20.0, 40)
gl.setCameraAngles(VEE_PI, -0.1 * VEE_PI)

# Make force invisible:
vq.toggleForceMode();
qa.setMainWidget(vq)
vq.show()
vq.resize(800, 500);

vq.setFrameFile("frames/Explosion-%.5d.png")

# vq.paramsVisible()

qa.execute()
