# Simple fire effect

# Usual initializations:
from vee_init import *
from vee import *

qa = QApplication_newApp()
scene = VEE_SceneBox()
VEE_ObjectFactory_init()


#############################################################################

# Initialize useful general-purpose variables

v1 = VEE_Vector3()
v2 = VEE_Vector3()

m1 = VEE_Matrix3()

#############################################################################

# Build a particle with nice colors, lifespan etc:

p = VEE_Polygon_createNewMesh(7, 7, 6.0, 3.0, 2.0)
p.thisown = 0

rgbatable = VEE_RgbaTable()
print rgbatable.thisown

color = VEE_Rgba()

color.set(0.7, 0.0, 0.0, 0.6)
rgbatable.appendColor(color)
color.set(0.7, 0.7, 0.3, 0.4)
rgbatable.appendColor(color)
color.set(0.3, 0.3, 0.3, 0.4)
rgbatable.appendColor(color)
color.set(0.0, 0.0, 0.0, 1.0)
rgbatable.appendColor(color)

looks = VEE_LooksColorTable(rgbatable)
looks.thisown = 0

valueLooks = VEE_ValueLooks()
valueLooks.setLooks(looks)

# p.setValue("looks", valueLooks)

m1.rotateZ(VEE_HALF_PI)
p.setValueMatrix3("transform", m1)

v1.clear();
p.setValueVector3("location", v1)


#############################################################################

# Now for the flame creator
creator =  VEE_Emitter(p)
creator.thisown = 0;
creator.setVisible(0)

# r = p.setValue("looks", valueLooks)


v1.make(-2.0, 0.0, -2.0)
v2.make(2.0, 0.5, 2.0)

rv = VEE_ValueRandomVector3()

rv.setRanges(v1, v2)

vo = VEE_ValueOperator()

vo.set("addvelocity", rv.clone())

creator.appendOperator(vo.clone())

vo.set("addlocation", rv.clone())
creator.appendOperator(vo.clone())

rf = VEE_ValueRandomFloat()
rf.set(0.5, 1.0)

vo.set("mass", rf.clone())
creator.appendOperator(vo.clone())

scene.addNewObject(creator)

rr = VEE_ValueRandomRotation()
vo.set("transform", rr.clone())
creator.appendOperator(vo.clone())

dtop = VEE_OperatorDt()
dtop.tthisown = 0
dtop.set(0.5, 1, 1)
dtop.setMaxStep(0.3)
creator.appendOperator(dtop)

#############################################################################

# Create a vortex generator:

vortex = VEE_ObjectFactory_create("vortex")
vortex.thisown = 0
vortex.setAgeLimit(1.5);
# vortex.setValueFloat("range", 1.0);
# vortex.setValueFloat("magnitude", 0.5);
# vortex.setValueFloat("maxforce", 10.5);
vortex.setVelocityUpdate(1)

screator = VEE_Emitter(vortex)
screator.setVisible(0)

vortexrange = VEE_ValueRandomFloat()
vortexrange.thisown = 0
vortexrangeop = VEE_ValueOperator()
vortexrangeop.set("range", vortexrange);
vortexrangeop.thisown = 0

screator.appendOperator(vortexrangeop)

# Random direction:
vo.set("axes", rv.clone())
screator.appendOperator(vo.clone())
# Randomize location:
vo.set("addlocation", rv.clone())
screator.appendOperator(vo.clone())
screator.setRate(1.0);


scene.addNewObject(screator)

#############################################################################

#############################################################################



paramView = VEE_ValueWindow()


vq = VEE_QT(scene)
# Make force invisible:
vq.toggleForceMode();
qa.setMainWidget(vq)

vq.raiseWidget()

vq.show()


qa.execute()
