# Simple fire effect

# Usual initializations:
from vee_init import *
from vee import *
import math
qa = QApplication_newApp()
scene = VEE_SceneBox()
VEE_ObjectFactory_init()
GEE_World_loadTextureDefinitions("vee-gl.config");

agelimit = 2.0
gravity = 5.0

ts = TimeStamp()

# GEE_Debug_setDebug("GEE_OperatorManager", 2);
# GEE_Debug_setDebug("GEE_OperatorGroup", 2);

vq = VEE_Qt(scene, VEE_GL_CG)
engine = vq.getGlWidget().geeEngine()
world = engine.world()


#############################################################################

# Make a path model

pa = GEE_PathInsert()
pa.autoId();
pa.setPathId(GEE_IdContainer_allocateId());
pa.thisown = 0;

path = pa.path()

vertex = GEE_PathVertex3D()
vertex.tip(1).make(0.2, 0, 0)
vertex.tip(2).make(0.2, 0.2, 0)

n = 30;
for i in range(0,n):
    vertex.m_location.make(5.0 * math.cos(2.0 * VEE_TWO_PI * i / n),
                           2 + (i * 5.5) / n ,
                           5.0 * math.sin(2.0 * VEE_TWO_PI * i / n))
    vertex.m_time = i * 0.2;
    path.addVertex(vertex)

engine.addOperator(pa)

ts = TimeStamp()
ts.setSeconds(path.endTime() + 0.5)

#############################################################################

# Create a profile:

profile = GEE_Profile()
profile.generateCircle(0.4, 12);
# profile.generateBar(0.4, 0.3);
# profile.getVertex(2).m_continues = 0;
#profile.getVertex(4).m_continues = 0;
#profile.getVertex(6).m_continues = 0;

#############################################################################

# Create a path multiplier:

multiply = GEE_PathMultiply(pa.pathId())
multiply.autoId()
multiply.setProfile(profile)
multiply.thisown = 0;
multiply.interval().setEnd(ts)

engine.addOperator(multiply)

for i in range(0, multiply.pathCount()):
    pl = GEE_PathToLines(multiply.pathId(i));
    pl.thisown = 0;
    pl.setKeepAlive(1);
    pl.interval().setEnd(ts)

    engine.addOperator(pl)
    
#############################################################################

# Make it visible:

# Make forces invisible:
vq.toggleForceMode();
qa.setMainWidget(vq)
vq.show()

print vq.renderer().subTextureCount()

qa.execute()

vq.getGlWidget().geeEngine().write("manylines.gee");
