/* COPYRIGHT
 *
 * This file is part of the Simple Object Loader and Renderer - SOLAR
 *
 * Read the file "SOLAR-LICENSE" for the license.
 *
 * Authors & Copyright:
 *
 * Tommi Ilmonen, 2001-2003, except LWO-code by RJ, 2001-2003
 *
 * Tommi's email: firstname.lastname@hut.fi
 *
 */

#include <Error.hpp>

#include <stdarg.h>
#include <stdio.h>

namespace Solar {

/// Print trace information to the user
extern void trace(const char *msg, ...)
{
  char buf[8196];
  va_list args;
  va_start(args, msg);
  vsprintf(buf, msg, args);
  printf("SOLAR TRACE # %s\n", buf);
  fflush(0);
  va_end(args);
}

/// Print error information to the user
extern void error(const char *msg, ...)
{
  char buf[8196];
  va_list args;
  va_start(args, msg);
  vsprintf(buf, msg, args);
  fprintf(stderr, "SOLAR ERROR # %s\n", buf);
  fflush(0);
  va_end(args);
}


/** Print error information to the user. Once the information has been
    written the application will be killed with segmentation fault. */
extern void fatal(const char *msg, ...)
{
  char buf[8196];
  va_list args;
  va_start(args, msg);
  vsprintf(buf, msg, args);
  fprintf(stderr, "SOLAR FATAL ERROR # %s\nINTENTIONAL SEGMENTATION FAULT !!\n",
	  buf);

  fflush(0);

  int *badAddress = 0;
  *badAddress = 1; // Segmentation fault
}


} // namespace Solar
