/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Simple Object Loader and Renderer - SOLAR
 *
 * Read the file "SOLAR-LICENSE" for the license.
 *
 * Authors & Copyright:
 *
 * Tommi Ilmonen, 2001-2003, except LWO-code by RJ, 2001-2003
 *
 * Tommi's email: firstname.lastname@hut.fi
 *
 */

#ifndef SOLAR_DELETED_HPP
#define SOLAR_DELETED_HPP

#include <set>

namespace Solar {

  class GarbageBin
  {
  public:
    GarbageBin() {}
    
    void add(void *item) { m_items.insert(item); }
    void clear() { m_items.clear(); }
    
    typedef std::set<void *>::iterator iterator;
    std::set<void *> m_items;
    
  };

  class Garbage
  {
  public:
    Garbage(GarbageBin *bin = 0) : m_bin(bin) {}
    virtual ~Garbage();
    
    virtual void setGarbageBin(GarbageBin *bin);

  private:
    GarbageBin * m_bin;
  };

} // namespace Solar

#endif
